Index: /trunk/tools/kBuildTools/VBoxXGccArm64Elf.kmk
===================================================================
--- /trunk/tools/kBuildTools/VBoxXGccArm64Elf.kmk	(revision 100473)
+++ /trunk/tools/kBuildTools/VBoxXGccArm64Elf.kmk	(revision 100474)
@@ -134,5 +134,5 @@
 TOOL_VBoxXGccArm64Elf_COMPILE_C_USES_KOBJCACHE = $(if-expr "$(use_objcache)" != "",1,)
 define TOOL_VBoxXGccArm64Elf_COMPILE_C_CMDS
-if "$(use_objcache)" != ""
+ if "$(use_objcache)" != ""
 	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -p\
 		--kObjCache-cpp $(outbase).i\
@@ -146,5 +146,5 @@
 		-o $(obj)\
 		-
-else
+ else
 	$(QUIET)$(TOOL_VBoxXGccArm64Elf_CC) -c\
 		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
@@ -152,5 +152,5 @@
 		-o $(obj)\
 		$(abspath $(source))
-endif
+ endif
 	$(QUIET)$(APPEND) -n "$(dep)" "" "$(source):" ""
 endef
@@ -174,5 +174,5 @@
 TOOL_VBoxXGccArm64Elf_COMPILE_CXX_USES_KOBJCACHE = $(if-expr "$(use_objcache)" != "",1,)
 define TOOL_VBoxXGccArm64Elf_COMPILE_CXX_CMDS
-if "$(use_objcache)" != ""
+ if "$(use_objcache)" != ""
 	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -p\
 		--kObjCache-cpp $(outbase).ii\
@@ -187,5 +187,5 @@
 		-o $(obj)\
 		-
-else
+ else
 	$(QUIET)$(TOOL_VBoxXGccArm64Elf_CXX) -c\
 		$(flags) $(qaddprefix sh,-I, $($(target)_1_GCC_PCH_DIR) $(incs)) $(qaddprefix sh,-D, $(defs))\
@@ -194,5 +194,5 @@
 		,-Winvalid-pch -include $(basename $($(target)_1_GCC_PCH_FILE)),) \
 		$(abspath $(source))
-endif
+ endif
 	$(QUIET)$(APPEND) -n "$(dep)" "" "$(source):" ""
 endef
@@ -295,6 +295,6 @@
 TOOL_VBoxXGccArm64Elf_LINK_PROGRAM_OUTPUT_DEBUG = $(outbase).debug
 TOOL_VBoxXGccArm64Elf_LINK_PROGRAM_DEBUG_INSTALL_FN = $(2).debug=>$(basename $(3)).debug
-TOOL_VBoxXGccArm64Elf_LINK_PROGRAM_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib)))\
-		$(filter %.def, $(othersrc))
+TOOL_VBoxXGccArm64Elf_LINK_PROGRAM_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) \
+	$(filter %.def, $(othersrc))
 TOOL_VBoxXGccArm64Elf_LINK_PROGRAM_DEPORD =
 define TOOL_VBoxXGccArm64Elf_LINK_PROGRAM_CMDS
@@ -302,5 +302,5 @@
 		$(filter %.def, $(othersrc))\
 		$(foreach p,$(libpath), -L$(p))\
-		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))\
+		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib))) \
 		$(call TOOL_VBoxXGccArm64Elf_LD_MAP,$(outbase).map)
  ifeq ($(ld_debug),split)
@@ -329,6 +329,6 @@
 TOOL_VBoxXGccArm64Elf_LINK_DLL_OUTPUT_DEBUG = $(outbase).debug
 TOOL_VBoxXGccArm64Elf_LINK_DLL_DEBUG_INSTALL_FN = $(2).debug=>$(basename $(3)).debug
-TOOL_VBoxXGccArm64Elf_LINK_DLL_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib)))\
-		$(filter %.def, $(othersrc))
+TOOL_VBoxXGccArm64Elf_LINK_DLL_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) \
+	$(filter %.def, $(othersrc))
 TOOL_VBoxXGccArm64Elf_LINK_DLL_DEPORD =
 define TOOL_VBoxXGccArm64Elf_LINK_DLL_CMDS
@@ -338,5 +338,5 @@
 		$(filter %.def, $(othersrc))\
 		$(foreach p,$(libpath), -L$(p))\
-		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))\
+		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib))) \
 		$(call TOOL_VBoxXGccArm64Elf_LD_MAP,$(outbase).map)
  ifeq ($(ld_debug),split)
@@ -365,9 +365,9 @@
 TOOL_VBoxXGccArm64Elf_LINK_SYSMOD_OUTPUT_DEBUG = $(outbase).debug
 TOOL_VBoxXGccArm64Elf_LINK_SYSMOD_DEBUG_INSTALL_FN = $(2).debug=>$(basename $(3)).debug
-TOOL_VBoxXGccArm64Elf_LINK_SYSMOD_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib)))\
-		$(filter %.def, $(othersrc))
+TOOL_VBoxXGccArm64Elf_LINK_SYSMOD_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) \
+	$(filter %.def, $(othersrc))
 TOOL_VBoxXGccArm64Elf_LINK_SYSMOD_DEPORD =
 define TOOL_VBoxXGccArm64Elf_LINK_SYSMOD_CMDS
-	$(QUIET)$(TOOL_VBoxXGccArm64Elf_LD_SYSMOD) $(TOOL_VBoxXGccArm64Elf_LDFLAGS.sysmod) $(flags) -o $(out) $(filter-out %.h.gch,$(objs))\
+	$(QUIET)$(TOOL_VBoxXGccArm64Elf_LD_SYSMOD) $(TOOL_VBoxXGccArm64Elf_LDFLAGS.sysmod) $(flags) -o $(out) $(filter-out %.h.gch,$(objs)) \
 		$(filter %.def, $(othersrc))\
 		$(foreach p,$(libpath), -L$(p))\
Index: /trunk/tools/kBuildTools/VBoxXGccArmNoneEabi.kmk
===================================================================
--- /trunk/tools/kBuildTools/VBoxXGccArmNoneEabi.kmk	(revision 100473)
+++ /trunk/tools/kBuildTools/VBoxXGccArmNoneEabi.kmk	(revision 100474)
@@ -134,5 +134,5 @@
 TOOL_VBoxXGccArmNoneEabi_COMPILE_C_USES_KOBJCACHE = $(if-expr "$(use_objcache)" != "",1,)
 define TOOL_VBoxXGccArmNoneEabi_COMPILE_C_CMDS
-if "$(use_objcache)" != ""
+ if "$(use_objcache)" != ""
 	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -p\
 		--kObjCache-cpp $(outbase).i\
@@ -146,5 +146,5 @@
 		-o $(obj)\
 		-
-else
+ else
 	$(QUIET)$(TOOL_VBoxXGccArmNoneEabi_CC) -c\
 		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
@@ -152,5 +152,5 @@
 		-o $(obj)\
 		$(abspath $(source))
-endif
+ endif
 	$(QUIET)$(APPEND) -n "$(dep)" "" "$(source):" ""
 endef
@@ -174,5 +174,5 @@
 TOOL_VBoxXGccArmNoneEabi_COMPILE_CXX_USES_KOBJCACHE = $(if-expr "$(use_objcache)" != "",1,)
 define TOOL_VBoxXGccArmNoneEabi_COMPILE_CXX_CMDS
-if "$(use_objcache)" != ""
+ if "$(use_objcache)" != ""
 	$(QUIET)$(KOBJCACHE) -f $(outbase).koc -d $(PATH_OBJCACHE) -t $(bld_trg).$(bld_trg_arch) -p\
 		--kObjCache-cpp $(outbase).ii\
@@ -187,5 +187,5 @@
 		-o $(obj)\
 		-
-else
+ else
 	$(QUIET)$(TOOL_VBoxXGccArmNoneEabi_CXX) -c\
 		$(flags) $(qaddprefix sh,-I, $($(target)_1_GCC_PCH_DIR) $(incs)) $(qaddprefix sh,-D, $(defs))\
@@ -194,5 +194,5 @@
 		,-Winvalid-pch -include $(basename $($(target)_1_GCC_PCH_FILE)),) \
 		$(abspath $(source))
-endif
+ endif
 	$(QUIET)$(APPEND) -n "$(dep)" "" "$(source):" ""
 endef
@@ -270,5 +270,5 @@
 		$(foreach o,$(filter-out %.def %.imp %.dll,$(othersrc)), 'ADDLIB $(o)')
 	$(if $(filter %.def %.imp %.dll,$(othersrc))\
-		,$(TOOL_VBoxXGccArmNoneEabi_AR_IMP) -o $(outbase).imp.a $(filter %.def %.imp %.dll,$(othersrc))\
+		,$(TOOL_VBoxXGccArmNoneEabi_AR_IMP) -o $(outbase).imp.a $(filter %.def %.imp %.dll,$(othersrc)) \
 		 $(NL)$(TAB)$(QUIET)$(APPEND) $(out).ar-script 'ADDLIB $(outbase).imp.a')
 	$(QUIET)$(APPEND) $(out).ar-script 'SAVE'
@@ -295,6 +295,6 @@
 TOOL_VBoxXGccArmNoneEabi_LINK_PROGRAM_OUTPUT_DEBUG = $(outbase).debug
 TOOL_VBoxXGccArmNoneEabi_LINK_PROGRAM_DEBUG_INSTALL_FN = $(2).debug=>$(basename $(3)).debug
-TOOL_VBoxXGccArmNoneEabi_LINK_PROGRAM_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib)))\
-		$(filter %.def, $(othersrc))
+TOOL_VBoxXGccArmNoneEabi_LINK_PROGRAM_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) \
+	$(filter %.def, $(othersrc))
 TOOL_VBoxXGccArmNoneEabi_LINK_PROGRAM_DEPORD =
 define TOOL_VBoxXGccArmNoneEabi_LINK_PROGRAM_CMDS
@@ -302,5 +302,5 @@
 		$(filter %.def, $(othersrc))\
 		$(foreach p,$(libpath), -L$(p))\
-		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))\
+		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib))) \
 		$(call TOOL_VBoxXGccArmNoneEabi_LD_MAP,$(outbase).map)
  ifeq ($(ld_debug),split)
@@ -329,14 +329,14 @@
 TOOL_VBoxXGccArmNoneEabi_LINK_DLL_OUTPUT_DEBUG = $(outbase).debug
 TOOL_VBoxXGccArmNoneEabi_LINK_DLL_DEBUG_INSTALL_FN = $(2).debug=>$(basename $(3)).debug
-TOOL_VBoxXGccArmNoneEabi_LINK_DLL_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib)))\
-		$(filter %.def, $(othersrc))
+TOOL_VBoxXGccArmNoneEabi_LINK_DLL_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) \
+	$(filter %.def, $(othersrc))
 TOOL_VBoxXGccArmNoneEabi_LINK_DLL_DEPORD =
 define TOOL_VBoxXGccArmNoneEabi_LINK_DLL_CMDS
 	$(QUIET)$(TOOL_VBoxXGccArmNoneEabi_LD) $(TOOL_VBoxXGccArmNoneEabi_LDFLAGS.dll) $(flags) -o $(out)\
-		$(if $(filter-out win os2, $(KBUILD_TARGET)),$(call TOOL_VBoxXGccArmNoneEabi_LD_SONAME,$(target),$(out)))\
+		$(if $(filter-out win os2, $(KBUILD_TARGET)),$(call TOOL_VBoxXGccArmNoneEabi_LD_SONAME,$(target),$(out))) \
 		$(filter-out %.h.gch,$(objs))\
 		$(filter %.def, $(othersrc))\
 		$(foreach p,$(libpath), -L$(p))\
-		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))\
+		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib))) \
 		$(call TOOL_VBoxXGccArmNoneEabi_LD_MAP,$(outbase).map)
  ifeq ($(ld_debug),split)
@@ -365,12 +365,12 @@
 TOOL_VBoxXGccArmNoneEabi_LINK_SYSMOD_OUTPUT_DEBUG = $(outbase).debug
 TOOL_VBoxXGccArmNoneEabi_LINK_SYSMOD_DEBUG_INSTALL_FN = $(2).debug=>$(basename $(3)).debug
-TOOL_VBoxXGccArmNoneEabi_LINK_SYSMOD_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib)))\
-		$(filter %.def, $(othersrc))
+TOOL_VBoxXGccArmNoneEabi_LINK_SYSMOD_DEPEND = $(foreach lib,$(libs),$(if $(findstring $(lib),$(subst /,x,$(lib))),, $(lib))) \
+	$(filter %.def, $(othersrc))
 TOOL_VBoxXGccArmNoneEabi_LINK_SYSMOD_DEPORD =
 define TOOL_VBoxXGccArmNoneEabi_LINK_SYSMOD_CMDS
-	$(QUIET)$(TOOL_VBoxXGccArmNoneEabi_LD_SYSMOD) $(TOOL_VBoxXGccArmNoneEabi_LDFLAGS.sysmod) $(flags) -o $(out) $(filter-out %.h.gch,$(objs))\
+	$(QUIET)$(TOOL_VBoxXGccArmNoneEabi_LD_SYSMOD) $(TOOL_VBoxXGccArmNoneEabi_LDFLAGS.sysmod) $(flags) -o $(out) $(filter-out %.h.gch,$(objs)) \
 		$(filter %.def, $(othersrc))\
 		$(foreach p,$(libpath), -L$(p))\
-		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib)))\
+		$(foreach lib,$(libs), $(if $(findstring $(lib),$(subst /,x,$(lib))), -l$(patsubst lib%,%,$(lib)), $(lib))) \
 		$(call TOOL_VBoxXGccArmNoneEabi_LD_SYSMOD_MAP,$(outbase).map)
  ifeq ($(ld_debug),split)