Index: trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-3-template.mac
===================================================================
--- trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-3-template.mac	(revision 100568)
+++ trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-3-template.mac	(revision 100569)
@@ -2600,36 +2600,4 @@
 
 ;
-; VBROADCASTSS
-;
-EMIT_INSTR_PLUS_ICEBP vbroadcastss, XMM1, XMM2
-EMIT_INSTR_PLUS_ICEBP vbroadcastss, XMM1, FSxBX
-EMIT_INSTR_PLUS_ICEBP vbroadcastss, YMM1, XMM2
-EMIT_INSTR_PLUS_ICEBP vbroadcastss, YMM1, FSxBX
- %if TMPL_BITS == 64
-EMIT_INSTR_PLUS_ICEBP vbroadcastss, XMM9, XMM8
-EMIT_INSTR_PLUS_ICEBP vbroadcastss, XMM9, FSxBX
-EMIT_INSTR_PLUS_ICEBP vbroadcastss, YMM9, XMM8
-EMIT_INSTR_PLUS_ICEBP vbroadcastss, YMM9, FSxBX
- %endif
-
-;
-; VBROADCASTSD
-;
-EMIT_INSTR_PLUS_ICEBP vbroadcastsd, YMM1, XMM2
-EMIT_INSTR_PLUS_ICEBP vbroadcastsd, YMM1, FSxBX
- %if TMPL_BITS == 64
-EMIT_INSTR_PLUS_ICEBP vbroadcastsd, YMM9, XMM8
-EMIT_INSTR_PLUS_ICEBP vbroadcastsd, YMM9, FSxBX
- %endif
-
-;
-; VBROADCASTF128
-;
-EMIT_INSTR_PLUS_ICEBP vbroadcastf128, YMM1, FSxBX
- %if TMPL_BITS == 64
-EMIT_INSTR_PLUS_ICEBP vbroadcastf128, YMM9, FSxBX
- %endif
-
-;
 ; SHA1NEXTE
 ;
Index: trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-3.c32
===================================================================
--- trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-3.c32	(revision 100568)
+++ trunk/src/VBox/ValidationKit/bootsectors/bs3-cpu-instr-3.c32	(revision 100569)
@@ -11075,101 +11075,4 @@
         {  bs3CpuInstr3_vphminposuw_XMM9_XMM8_icebp_c64,  255,         RM_REG, T_AVX_128,   9,   8, RT_ELEMENTS(s_aValues), s_aValues },
         {  bs3CpuInstr3_vphminposuw_XMM9_FSxBX_icebp_c64, X86_XCPT_DB, RM_MEM, T_AVX_128,   9, 255, RT_ELEMENTS(s_aValues), s_aValues },
-    };
-    static BS3CPUINSTR3_TEST3_MODE_T const s_aTests[3] = BS3CPUINSTR3_TEST3_MODES_INIT(s_aTests16, s_aTests32, s_aTests64);
-    unsigned const                         iTest       = BS3CPUINSTR3_TEST_MODES_INDEX(bMode);
-    return bs3CpuInstr3_WorkerTestType3(bMode, s_aTests[iTest].paTests, s_aTests[iTest].cTests,
-                                        g_aXcptConfig4, RT_ELEMENTS(g_aXcptConfig4), X86_EFL_STATUS_BITS);
-}
-
-
-/*
- * VBROADCASTSS/VBROADCASTSD
- */
-BS3_FNBS3FAR_PROTOTYPES_CMN(bs3CpuInstr3_vbroadcastss_XMM1_XMM2_icebp);
-BS3_FNBS3FAR_PROTOTYPES_CMN(bs3CpuInstr3_vbroadcastss_XMM1_FSxBX_icebp);
-extern FNBS3FAR             bs3CpuInstr3_vbroadcastss_XMM9_XMM8_icebp_c64;
-extern FNBS3FAR             bs3CpuInstr3_vbroadcastss_XMM9_FSxBX_icebp_c64;
-BS3_FNBS3FAR_PROTOTYPES_CMN(bs3CpuInstr3_vbroadcastss_YMM1_XMM2_icebp);
-BS3_FNBS3FAR_PROTOTYPES_CMN(bs3CpuInstr3_vbroadcastss_YMM1_FSxBX_icebp);
-extern FNBS3FAR             bs3CpuInstr3_vbroadcastss_YMM9_XMM8_icebp_c64;
-extern FNBS3FAR             bs3CpuInstr3_vbroadcastss_YMM9_FSxBX_icebp_c64;
-
-BS3_FNBS3FAR_PROTOTYPES_CMN(bs3CpuInstr3_vbroadcastsd_YMM1_XMM2_icebp);
-BS3_FNBS3FAR_PROTOTYPES_CMN(bs3CpuInstr3_vbroadcastsd_YMM1_FSxBX_icebp);
-extern FNBS3FAR             bs3CpuInstr3_vbroadcastsd_YMM9_XMM8_icebp_c64;
-extern FNBS3FAR             bs3CpuInstr3_vbroadcastsd_YMM9_FSxBX_icebp_c64;
-
-BS3_FNBS3FAR_PROTOTYPES_CMN(bs3CpuInstr3_vbroadcastf128_YMM1_FSxBX_icebp);
-extern FNBS3FAR             bs3CpuInstr3_vbroadcastf128_YMM9_FSxBX_icebp_c64;
-
-BS3_DECL_FAR(uint8_t) bs3CpuInstr3_vbroadcastss_vbroadcastsd_vbroadcastf128(uint8_t bMode)
-{
-    static BS3CPUINSTR3_TEST3_VALUES_T const s_aValues32[] =
-    {
-        {            RTUINT256_INIT_C(0, 0, 0, 0),
-            /* => */ RTUINT256_INIT_C(0, 0, 0, 0) },
-        {            RTUINT256_INIT_C(0x8888888877777777, 0x6666666655555555, 0x4444444433333333, 0x2222222211111111),
-            /* => */ RTUINT256_INIT_C(0x1111111111111111, 0x1111111111111111, 0x1111111111111111, 0x1111111111111111) },
-    };
-
-    static BS3CPUINSTR3_TEST3_VALUES_T const s_aValues64[] =
-    {
-        {            RTUINT256_INIT_C(0, 0, 0, 0),
-            /* => */ RTUINT256_INIT_C(0, 0, 0, 0) },
-        {            RTUINT256_INIT_C(0x4444444444444444, 0x3333333333333333, 0x2222222222222222, 0x1111111111111111),
-            /* => */ RTUINT256_INIT_C(0x1111111111111111, 0x1111111111111111, 0x1111111111111111, 0x1111111111111111) },
-    };
-
-    static BS3CPUINSTR3_TEST3_VALUES_T const s_aValues128[] =
-    {
-        {            RTUINT256_INIT_C(0, 0, 0, 0),
-            /* => */ RTUINT256_INIT_C(0, 0, 0, 0) },
-        {            RTUINT256_INIT_C(0x4444444444444444, 0x3333333333333333, 0x2222222222222222, 0x1111111111111111),
-            /* => */ RTUINT256_INIT_C(0x2222222222222222, 0x1111111111111111, 0x2222222222222222, 0x1111111111111111) },
-    };
-
-    static BS3CPUINSTR3_TEST3_T const s_aTests16[] =
-    {
-        {  bs3CpuInstr3_vbroadcastss_XMM1_XMM2_icebp_c16,   255,         RM_REG, T_AVX2_128,    1,   2, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_XMM1_FSxBX_icebp_c16,  X86_XCPT_AC, RM_MEM, T_AVX_128,     1, 255, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_YMM1_XMM2_icebp_c16,   255,         RM_REG, T_AVX2_256,    1,   2, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_YMM1_FSxBX_icebp_c16,  X86_XCPT_AC, RM_MEM, T_AVX_256,     1, 255, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-
-        {  bs3CpuInstr3_vbroadcastsd_YMM1_XMM2_icebp_c16,   255,         RM_REG, T_AVX2_256,    1,   2, RT_ELEMENTS(s_aValues64),  s_aValues64  },
-        {  bs3CpuInstr3_vbroadcastsd_YMM1_FSxBX_icebp_c16,  X86_XCPT_AC, RM_MEM, T_AVX_256,     1, 255, RT_ELEMENTS(s_aValues64),  s_aValues64  },
-
-        {  bs3CpuInstr3_vbroadcastf128_YMM1_FSxBX_icebp_c16, X86_XCPT_DB, RM_MEM, T_AVX_256,    1, 255, RT_ELEMENTS(s_aValues128), s_aValues128 },
-    };
-    static BS3CPUINSTR3_TEST3_T const s_aTests32[] =
-    {
-        {  bs3CpuInstr3_vbroadcastss_XMM1_XMM2_icebp_c32,   255,         RM_REG, T_AVX2_128,    1,   2, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_XMM1_FSxBX_icebp_c32,  X86_XCPT_AC, RM_MEM, T_AVX_128,     1, 255, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_YMM1_XMM2_icebp_c32,   255,         RM_REG, T_AVX2_256,    1,   2, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_YMM1_FSxBX_icebp_c32,  X86_XCPT_AC, RM_MEM, T_AVX_256,     1, 255, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-
-        {  bs3CpuInstr3_vbroadcastsd_YMM1_XMM2_icebp_c32,   255,         RM_REG, T_AVX2_256,    1,   2, RT_ELEMENTS(s_aValues64),  s_aValues64  },
-        {  bs3CpuInstr3_vbroadcastsd_YMM1_FSxBX_icebp_c32,  X86_XCPT_AC, RM_MEM, T_AVX_256,     1, 255, RT_ELEMENTS(s_aValues64),  s_aValues64  },
-
-        {  bs3CpuInstr3_vbroadcastf128_YMM1_FSxBX_icebp_c32, X86_XCPT_DB, RM_MEM, T_AVX_256,    1, 255, RT_ELEMENTS(s_aValues128), s_aValues128 },
-    };
-    static BS3CPUINSTR3_TEST3_T const s_aTests64[] =
-    {
-        {  bs3CpuInstr3_vbroadcastss_XMM1_XMM2_icebp_c64,   255,         RM_REG, T_AVX2_128,    1,   2, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_XMM1_FSxBX_icebp_c64,  X86_XCPT_AC, RM_MEM, T_AVX_128,     1, 255, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_XMM9_XMM8_icebp_c64,   255,         RM_REG, T_AVX2_128,    9,   8, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_XMM9_FSxBX_icebp_c64,  X86_XCPT_AC, RM_MEM, T_AVX_128,     9, 255, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_YMM1_XMM2_icebp_c64,   255,         RM_REG, T_AVX2_256,    1,   2, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_YMM1_FSxBX_icebp_c64,  X86_XCPT_AC, RM_MEM, T_AVX_256,     1, 255, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_YMM9_XMM8_icebp_c64,   255,         RM_REG, T_AVX2_256,    9,   8, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-        {  bs3CpuInstr3_vbroadcastss_YMM9_FSxBX_icebp_c64,  X86_XCPT_AC, RM_MEM, T_AVX_256,     9, 255, RT_ELEMENTS(s_aValues32),  s_aValues32  },
-
-        {  bs3CpuInstr3_vbroadcastsd_YMM1_XMM2_icebp_c64,   255,         RM_REG, T_AVX2_256,    1,   2, RT_ELEMENTS(s_aValues64),  s_aValues64  },
-        {  bs3CpuInstr3_vbroadcastsd_YMM1_FSxBX_icebp_c64,  X86_XCPT_AC, RM_MEM, T_AVX_256,     1, 255, RT_ELEMENTS(s_aValues64),  s_aValues64  },
-        {  bs3CpuInstr3_vbroadcastsd_YMM9_XMM8_icebp_c64,   255,         RM_REG, T_AVX2_256,    9,   8, RT_ELEMENTS(s_aValues64),  s_aValues64  },
-        {  bs3CpuInstr3_vbroadcastsd_YMM9_FSxBX_icebp_c64,  X86_XCPT_AC, RM_MEM, T_AVX_256,     9, 255, RT_ELEMENTS(s_aValues64),  s_aValues64  },
-
-        {  bs3CpuInstr3_vbroadcastf128_YMM1_FSxBX_icebp_c64, X86_XCPT_DB, RM_MEM, T_AVX_256,    1, 255, RT_ELEMENTS(s_aValues128), s_aValues128 },
-        {  bs3CpuInstr3_vbroadcastf128_YMM9_FSxBX_icebp_c64, X86_XCPT_DB, RM_MEM, T_AVX_256,    9, 255, RT_ELEMENTS(s_aValues128), s_aValues128 },
-
     };
     static BS3CPUINSTR3_TEST3_MODE_T const s_aTests[3] = BS3CPUINSTR3_TEST3_MODES_INIT(s_aTests16, s_aTests32, s_aTests64);
@@ -12647,9 +12550,6 @@
 #endif
 #if defined (ALL_TESTS)
-        { "mpsadbw",                                        bs3CpuInstr3_v_mpsadbw, 0 },
-
-#endif
-#if defined(ALL_TESTS)
-        { "vbroadcastss/vbroadcastsd/vbroadcastf128",       bs3CpuInstr3_vbroadcastss_vbroadcastsd_vbroadcastf128,   0 }
+        { "mpsadbw",                                        bs3CpuInstr3_v_mpsadbw, 0 }
+
 #endif
     };