Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 100593)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 100594)
@@ -291,4 +291,5 @@
         <file alias="file_manager_folder_remove_16px.png">images/file_manager_folder_remove_16px.png</file>
         <file alias="file_manager_folder_symlink_16px.png">images/file_manager_folder_symlink_16px.png</file>
+        <file alias="file_manager_folder_warning_16px.png">images/file_manager_folder_warning_16px.png</file>
         <file alias="file_manager_go_backward_16px.png">images/file_manager_go_backward_16px.png</file>
         <file alias="file_manager_go_backward_24px.png">images/file_manager_go_backward_24px.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x2.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x2.qrc	(revision 100593)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x2.qrc	(revision 100594)
@@ -291,4 +291,5 @@
         <file alias="file_manager_folder_remove_16px_x2.png">images/x2/file_manager_folder_remove_16px_x2.png</file>
         <file alias="file_manager_folder_symlink_16px_x2.png">images/x2/file_manager_folder_symlink_16px_x2.png</file>
+        <file alias="file_manager_folder_warning_16px_x2.png">images/x2/file_manager_folder_warning_16px_x2.png</file>
         <file alias="file_manager_go_backward_16px_x2.png">images/x2/file_manager_go_backward_16px_x2.png</file>
         <file alias="file_manager_go_backward_24px_x2.png">images/x2/file_manager_go_backward_24px_x2.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x3.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x3.qrc	(revision 100593)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x3.qrc	(revision 100594)
@@ -291,4 +291,5 @@
         <file alias="file_manager_folder_remove_16px_x3.png">images/x3/file_manager_folder_remove_16px_x3.png</file>
         <file alias="file_manager_folder_symlink_16px_x3.png">images/x3/file_manager_folder_symlink_16px_x3.png</file>
+        <file alias="file_manager_folder_warning_16px_x3.png">images/x3/file_manager_folder_warning_16px_x3.png</file>
         <file alias="file_manager_go_backward_16px_x3.png">images/x3/file_manager_go_backward_16px_x3.png</file>
         <file alias="file_manager_go_backward_24px_x3.png">images/x3/file_manager_go_backward_24px_x3.png</file>
@@ -500,5 +501,4 @@
         <file alias="keyboard_settings_16px_x3.png">images/x3/keyboard_settings_16px_x3.png</file>
         <file alias="keyboard_settings_disabled_16px_x3.png">images/x3/keyboard_settings_disabled_16px_x3.png</file>
-        <file alias="launch_vm_16px_x3.png">images/x3/launch_vm_16px_x3.png</file>
     </qresource>
 </RCC>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x4.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x4.qrc	(revision 100593)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x4.qrc	(revision 100594)
@@ -291,4 +291,5 @@
         <file alias="file_manager_folder_remove_16px_x4.png">images/x4/file_manager_folder_remove_16px_x4.png</file>
         <file alias="file_manager_folder_symlink_16px_x4.png">images/x4/file_manager_folder_symlink_16px_x4.png</file>
+        <file alias="file_manager_folder_warning_16px_x4.png">images/x4/file_manager_folder_warning_16px_x4.png</file>
         <file alias="file_manager_go_backward_16px_x4.png">images/x4/file_manager_go_backward_16px_x4.png</file>
         <file alias="file_manager_go_backward_24px_x4.png">images/x4/file_manager_go_backward_24px_x4.png</file>
@@ -500,5 +501,4 @@
         <file alias="keyboard_settings_16px_x4.png">images/x4/keyboard_settings_16px_x4.png</file>
         <file alias="keyboard_settings_disabled_16px_x4.png">images/x4/keyboard_settings_disabled_16px_x4.png</file>
-        <file alias="launch_vm_16px_x4.png">images/x4/launch_vm_16px_x4.png</file>
     </qresource>
 </RCC>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x3.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x3.qrc	(revision 100593)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x3.qrc	(revision 100594)
@@ -1,4 +1,5 @@
 <RCC>
     <qresource suffix="/">
+        <file alias="launch_vm_16px_x3.png">images/x3/launch_vm_16px_x3.png</file>
         <file alias="list_movedown_16px_x3.png">images/x3/list_movedown_16px_x3.png</file>
         <file alias="list_movedown_disabled_16px_x3.png">images/x3/list_movedown_disabled_16px_x3.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x4.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x4.qrc	(revision 100593)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x4.qrc	(revision 100594)
@@ -1,4 +1,5 @@
 <RCC>
     <qresource suffix="/">
+        <file alias="launch_vm_16px_x4.png">images/x4/launch_vm_16px_x4.png</file>
         <file alias="list_movedown_16px_x4.png">images/x4/list_movedown_16px_x4.png</file>
         <file alias="list_movedown_disabled_16px_x4.png">images/x4/list_movedown_disabled_16px_x4.png</file>