Index: /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-darwin.cpp
===================================================================
--- /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-darwin.cpp	(revision 100645)
+++ /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-darwin.cpp	(revision 100646)
@@ -96,5 +96,5 @@
         && fChanged
         && ShClSvcIsBackendActive())
-        rc = ShClSvcHostReportFormats(pCtx->pClient, fFormats);
+        rc = ShClSvcReportFormats(pCtx->pClient, fFormats);
 
     LogFlowFuncLeaveRC(rc);
Index: /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-internal.h
===================================================================
--- /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-internal.h	(revision 100645)
+++ /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-internal.h	(revision 100646)
@@ -313,5 +313,5 @@
 int ShClSvcReadDataFromGuest(PSHCLCLIENT pClient, SHCLFORMAT uFmt, void **ppv, uint32_t *pcb);
 int ShClSvcGuestDataSignal(PSHCLCLIENT pClient, PSHCLCLIENTCMDCTX pCmdCtx, SHCLFORMAT uFormat, void *pvData, uint32_t cbData);
-int ShClSvcHostReportFormats(PSHCLCLIENT pClient, SHCLFORMATS fFormats);
+int ShClSvcReportFormats(PSHCLCLIENT pClient, SHCLFORMATS fFormats);
 PSHCLBACKEND ShClSvcGetBackend(void);
 uint32_t ShClSvcGetMode(void);
Index: /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-win.cpp
===================================================================
--- /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-win.cpp	(revision 100645)
+++ /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-win.cpp	(revision 100646)
@@ -792,5 +792,5 @@
             && fFormats != VBOX_SHCL_FMT_NONE /** @todo r=bird: BUGBUG: revisit this. */
             && ShClSvcIsBackendActive())
-            rc = ShClSvcHostReportFormats(pCtx->pClient, fFormats);
+            rc = ShClSvcReportFormats(pCtx->pClient, fFormats);
     }
     else /* If we don't have any client data (yet), bail out. */
Index: /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-x11.cpp
===================================================================
--- /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-x11.cpp	(revision 100645)
+++ /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-x11.cpp	(revision 100646)
@@ -221,5 +221,5 @@
      * the guest when the clipboard starts up. */
     if (ShClSvcIsBackendActive())
-        return ShClSvcHostReportFormats(pClient, VBOX_SHCL_FMT_NONE);
+        return ShClSvcReportFormats(pClient, VBOX_SHCL_FMT_NONE);
     return VINF_SUCCESS;
 }
@@ -377,5 +377,5 @@
             if (fFormats != VBOX_SHCL_FMT_NONE) /* No formats to report? */
             {
-                rc = ShClSvcHostReportFormats(pCtx->pClient, fFormats);
+                rc = ShClSvcReportFormats(pCtx->pClient, fFormats);
             }
         }
Index: /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp
===================================================================
--- /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp	(revision 100645)
+++ /trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc.cpp	(revision 100646)
@@ -1484,5 +1484,5 @@
  * @thread  Backend thread.
  */
-int ShClSvcHostReportFormats(PSHCLCLIENT pClient, SHCLFORMATS fFormats)
+int ShClSvcReportFormats(PSHCLCLIENT pClient, SHCLFORMATS fFormats)
 {
     LogFlowFuncEnter();
@@ -1775,5 +1775,5 @@
         if (g_ExtState.fDelayedAnnouncement)
         {
-            int rc2 = ShClSvcHostReportFormats(pClient, g_ExtState.fDelayedFormats);
+            int rc2 = ShClSvcReportFormats(pClient, g_ExtState.fDelayedFormats);
             AssertRC(rc2);
 
@@ -2735,5 +2735,5 @@
                 LogFlowFunc(("VBOX_CLIPBOARD_EXT_FN_FORMAT_ANNOUNCE: g_ExtState.fReadingData=%RTbool\n", g_ExtState.fReadingData));
                 if (!g_ExtState.fReadingData)
-                    rc = ShClSvcHostReportFormats(pClient, u32Format);
+                    rc = ShClSvcReportFormats(pClient, u32Format);
                 else
                 {